/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package tp3;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.OneToMany;

/**
 *
 * @author alix
 */
@Entity
public class CompteBancaire implements Serializable {
    private static final long serialVersionUID = 1L;
    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    private Long id;
    private String nom;
    @OneToMany(cascade={CascadeType.ALL}, fetch=FetchType.EAGER)
    private List<OperationBancaire> operations = new ArrayList<OperationBancaire>();

    public CompteBancaire() {
    }

    public List<OperationBancaire> getOperations() {
        return operations;
    }

    public void setOperations(List<OperationBancaire> operations) {
        this.operations = operations;
    }
    
    public void addOperation(OperationBancaire operation) {
        operations.add(operation);
    }
    
    public void removeOperation(OperationBancaire operation) {
        operations.remove(operation);
    }

    public CompteBancaire(String nom, double soldeInit) {
        this.nom = nom;
        OperationBancaire op = new OperationBancaire("Création du comptes", soldeInit);
        operations.add(op);
    }
    
    // Solde
    public double getSolde() {
        double soldecourant = 0;
        for (OperationBancaire operationBancaire : operations) {
            soldecourant += operationBancaire.getMontant();
        }
        
        return soldecourant;
    }
    
    public void deposit(Double amount){
        OperationBancaire op = new OperationBancaire("Dépot", amount);
        operations.add(op);
    }
    
    public void deposit(Double amount, String message){
        OperationBancaire op = new OperationBancaire(message, amount);
        operations.add(op);
    }
    
    public void withdrawal(Double amount){
        OperationBancaire op = new OperationBancaire("Retrait", amount);
        operations.add(op);
    }
    
    public void withdrawal(Double amount, String message){
        OperationBancaire op = new OperationBancaire(message, amount);
        operations.add(op);
    }
    
    // Nom
    public String getNom() {
        return nom;
    }

    public void setNom(String nom) {
        this.nom = nom;
    }

    // ID
    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (id != null ? id.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof CompteBancaire)) {
            return false;
        }
        CompteBancaire other = (CompteBancaire) object;
        if ((this.id == null && other.id != null) || (this.id != null && !this.id.equals(other.id))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "tp3.CompteBancaire[ id=" + id + " ]";
    }
    
}
