/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package managedbean;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import javax.ejb.EJB;
import javax.enterprise.context.SessionScoped;
import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.convert.Converter;
import javax.inject.Named;
import session.GestionnaireDeCompteBancaire;
import tp3.CompteBancaire;

/**
 *
 * @author alix
 */
@Named(value = "compteBancaireMBean")
@SessionScoped
public class CompteBancaireMBean implements Serializable {

    @EJB
    private GestionnaireDeCompteBancaire gestionnaireDeCompteBancaire;
    private CompteBancaire compte;
    private String nom;
    private double solde;
    private String typeOperation;
    private double montant;

    public String getTypeOperation() {
        return typeOperation;
    }

    public void setTypeOperation(String typeOperation) {
        this.typeOperation = typeOperation;
    }

    public double getMontant() {
        return montant;
    }

    public void setMontant(double montant) {
        this.montant = montant;
    }

    public String getNom() {
        return nom;
    }

    public void setNom(String nom) {
        this.nom = nom;
    }

    public double getSolde() {
        return solde;
    }

    public void setSolde(double solde) {
        this.solde = solde;
    }
    
    // modele pour le tableau
    List<CompteBancaire> comptes;
    /**
     * Creates a new instance of CompteBancaireMBean
     */
    public CompteBancaireMBean() {
        
    }
    
    /** 
    * Renvoie la liste des comptes pour affichage dans une DataTable 
    * @return 
    */  
    public List<CompteBancaire>getComptes() {
        if(comptes == null) {
            refresh();
        }
        
        return comptes;
    }
    
    public void refresh() {
        comptes = gestionnaireDeCompteBancaire.getAllComptes();  
    }
     
    public CompteBancaire getDetails() {  
        return compte;  
    }  
  
    public String showDetails(CompteBancaire compte) {  
        this.compte = compte;  
        return "show?faces-redirect=true";  
    }  
    
    // MAJ des informations d'un compte
    public String update() {  
        System.out.println("###UPDATE###");  
        compte = gestionnaireDeCompteBancaire.update(compte);  
        return "index?faces-redirect=true";  
    }
    
    /** 
     * Action handler -  Supprime le compte
     * @return String
     */  
    public String delete() {  
        System.out.println("###DELETE###");  
        gestionnaireDeCompteBancaire.delete(compte);
        // MAJ
        this.refresh();
        return "index?faces-redirect=true";  
    }
    
    /** 
     * Action handler - renvoie vers la page qui affiche la liste des clients 
     * @return 
     */  
    public String list() {  
        System.out.println("###LIST###");  
        return "index?faces-redirect=true";  
    }
    
    /** 
     * Action handler -  Créer un nouveau compte
     * @return String
     */ 
    public String create() {
        System.out.println("###CREATE###");
        // Creation du nouveau compte
        CompteBancaire nouveauCompte = new CompteBancaire(this.nom, this.solde);
        gestionnaireDeCompteBancaire.creerCompte(nouveauCompte);
        // Rafraichir la liste des comptes
        this.refresh();
        // Vider les variables;
        this.nom = "";
        this.solde = 0;
        
        return "index?faces-redirect=true";
    }
    
    public String operation() {
        System.out.println("###CREATE OPERATION###");
        // Creation d'une nouvelle opération
        if(typeOperation.equals("withdrawal")) {
            compte.withdrawal(-montant);
        }
        else if(typeOperation.equals("deposit")) {
            compte.deposit(montant);
        }
        
        // MAJ
        compte = gestionnaireDeCompteBancaire.update(compte);
        refresh();
        
        // Reinitialiser les variables
        this.montant = 0;
        this.typeOperation = "";
        
        return "show?faces-redirect=true";
    }
    
    // Transfert
    private CompteBancaire deCompte;
    private CompteBancaire versCompte;
    private double montantTransfert;

    public CompteBancaire getDeCompte() {
        return deCompte;
    }

    public void setDeCompte(CompteBancaire deCompte) {
        this.deCompte = deCompte;
    }

    public CompteBancaire getVersCompte() {
        return versCompte;
    }

    public void setVersCompte(CompteBancaire versCompte) {
        this.versCompte = versCompte;
    }

    public double getMontantTransfert() {
        return montantTransfert;
    }

    public void setMontantTransfert(double montantTransfert) {
        this.montantTransfert = montantTransfert;
    }

    public String transfert() {
        // PAS BON, Pas dans une seule transaction !!!!!!!
        /*
        deCompte.withdrawal(-montantTransfert, "Virement vers "+versCompte.getNom());
        versCompte.deposit(montantTransfert, "Virement de: "+deCompte.getNom());
        
        // MAJ des comptes
        gestionnaireDeCompteBancaire.update(deCompte);
        gestionnaireDeCompteBancaire.update(versCompte);
        */
        
        gestionnaireDeCompteBancaire.transfer(deCompte, versCompte, montantTransfert);
        // Refresh 
        refresh();
        
        // Vider les variables
        deCompte = null;
        versCompte = null;
        montantTransfert = 0;
        
        return "index?faces-redirect=true";
    }
    
    // Autocomplete
    private Converter converter = new Converter() {

        @Override
        public Object getAsObject(FacesContext context, UIComponent component, String value) {
            return gestionnaireDeCompteBancaire.getCompte(Integer.parseInt(value));
        }

        @Override
        public String getAsString(FacesContext context, UIComponent component, Object value) {
            CompteBancaire c = (CompteBancaire) value;
            
            return c.getId().toString();
        }
        
    };

    public Converter getConverter() {
        return converter;
    }

    public void setConverter(Converter converter) {
        this.converter = converter;
    }

    public List<CompteBancaire> completeCompte(String query) {
        return gestionnaireDeCompteBancaire.findComptes(query);
    }
    
}
